/*
  Copyright (c) 2011 Alex Diener
  
  This software is provided 'as-is', without any express or implied
  warranty. In no event will the authors be held liable for any damages
  arising from the use of this software.
  
  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:
  
  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
  
  Alex Diener adiener@sacredsoftware.net
*/

#ifndef __DUNGEON_KEY_MODEL_H__
#define __DUNGEON_KEY_MODEL_H__

typedef struct DungeonKeyModel DungeonKeyModel;

#include "convergence/GameObjectModel.h"

#define KEY_RADIUS 0.4375f

#define DungeonKeyModel_structContents \
	GameObjectModel_structContents \
	\
	int keyID; \
	Vector2 position;

struct DungeonKeyModel {
	DungeonKeyModel_structContents
};

DungeonKeyModel * DungeonKeyModel_create(DungeonRoomStateModel * stateModel, int keyID, Vector2 position);
void DungeonKeyModel_init(compat_type(DungeonKeyModel *) selfPtr, DungeonRoomStateModel * stateModel, int keyID, Vector2 position);
void DungeonKeyModel_initCopy(compat_type(DungeonKeyModel *) selfPtr, compat_type(DungeonKeyModel *) originalPtr);
void DungeonKeyModel_dispose(compat_type(DungeonKeyModel *) selfPtr);

compat_type(DungeonKeyModel *) DungeonKeyModel_copy(compat_type(DungeonKeyModel *) selfPtr);
struct rect4f DungeonKeyModel_roughBounds(compat_type(DungeonKeyModel *) selfPtr);
struct collisionGeometry DungeonKeyModel_collisionGeometry(compat_type(DungeonKeyModel *) selfPtr);
bool DungeonKeyModel_wouldCollide(compat_type(DungeonKeyModel *) selfPtr, compat_type(GameObjectModel *) objectPtr);
void DungeonKeyModel_collision(compat_type(DungeonKeyModel *) selfPtr, compat_type(GameObjectModel *) objectPtr, const struct collision collision, float time);

#endif
