/*
  Copyright (c) 2011 Alex Diener
  
  This software is provided 'as-is', without any express or implied
  warranty. In no event will the authors be held liable for any damages
  arising from the use of this software.
  
  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:
  
  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
  
  Alex Diener adiener@sacredsoftware.net
*/

#ifndef __DUNGEON_TILE_COLOR_MAP_H__
#define __DUNGEON_TILE_COLOR_MAP_H__

typedef struct DungeonTileColorMap DungeonTileColorMap;

#define DUNGEON_TILE_COLOR_MAP_SERIALIZATION_FORMAT_VERSION 0

#include "convergence/DungeonRoomModel.h"
#include "serialization/DeserializationContext.h"
#include "serialization/SerializationContext.h"
#include "stemobject/StemObject.h"
#include "utilities/Atom.h"
#include <stdint.h>

struct DungeonTileColorMap_color {
	uint32_t color;
	DungeonTileType type;
	Atom canvasTileID;
};

#define DungeonTileColorMap_structContents \
	StemObject_structContents \
	\
	size_t colorCount; \
	struct DungeonTileColorMap_color * colors;

struct DungeonTileColorMap {
	DungeonTileColorMap_structContents
};

DungeonTileColorMap * DungeonTileColorMap_create();
void DungeonTileColorMap_init(compat_type(DungeonTileColorMap *) selfPtr);
void DungeonTileColorMap_dispose(compat_type(DungeonTileColorMap *) selfPtr);

DungeonTileColorMap * DungeonTileColorMap_deserialize(compat_type(DeserializationContext *) deserializationContext);
bool DungeonTileColorMap_loadSerializedData(compat_type(DungeonTileColorMap *) selfPtr, compat_type(DeserializationContext *) deserializationContext);
void DungeonTileColorMap_serialize(compat_type(DungeonTileColorMap *) selfPtr, compat_type(SerializationContext *) serializationContext);

#endif
