/*
  Copyright (c) 2011 Alex Diener
  
  This software is provided 'as-is', without any express or implied
  warranty. In no event will the authors be held liable for any damages
  arising from the use of this software.
  
  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:
  
  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
  
  Alex Diener adiener@sacredsoftware.net
*/

#ifndef __ENEMY_FIRST_BOSS_MODEL_H__
#define __ENEMY_FIRST_BOSS_MODEL_H__

typedef struct EnemyFirstBossModel EnemyFirstBossModel;

#include "convergence/EnemyModel.h"

#define EnemyFirstBossModel_structContents \
	EnemyModel_structContents \
	\
	int shotsLeft; \
	int attackCooldown; \
	int shootCooldown; \
	Direction swordSwingFacing; \
	int swordSwingFacingCooldown;

struct EnemyFirstBossModel {
	EnemyFirstBossModel_structContents
};

EnemyFirstBossModel * EnemyFirstBossModel_create(DungeonRoomStateModel * stateModel, int rank, Vector2 position, Direction facing, size_t inventoryItemCount, struct InventoryModel_item * inventoryItems, size_t patrolWaypointCount, Vector2 * patrolWaypoints);
void EnemyFirstBossModel_init(compat_type(EnemyFirstBossModel *) selfPtr, DungeonRoomStateModel * stateModel, int rank, Vector2 position, Direction facing, size_t inventoryItemCount, struct InventoryModel_item * inventoryItems, size_t patrolWaypointCount, Vector2 * patrolWaypoints);
void EnemyFirstBossModel_initCopy(compat_type(EnemyFirstBossModel *) selfPtr, compat_type(EnemyFirstBossModel *) originalPtr);
void EnemyFirstBossModel_dispose(compat_type(EnemyFirstBossModel *) selfPtr);

compat_type(EnemyFirstBossModel *) EnemyFirstBossModel_copy(compat_type(EnemyFirstBossModel *) selfPtr);
void EnemyFirstBossModel_update(compat_type(EnemyFirstBossModel *) selfPtr);
void EnemyFirstBossModel_aiUpdate(compat_type(EnemyFirstBossModel *) selfPtr);
bool EnemyFirstBossModel_atRest(compat_type(EnemyFirstBossModel *) selfPtr);
void EnemyFirstBossModel_attack(compat_type(EnemyFirstBossModel *) selfPtr);
void EnemyFirstBossModel_takeDamage(compat_type(EnemyFirstBossModel *) selfPtr, int amount, Direction fromDirection);

#endif
