/*
  Copyright (c) 2011 Alex Diener
  
  This software is provided 'as-is', without any express or implied
  warranty. In no event will the authors be held liable for any damages
  arising from the use of this software.
  
  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:
  
  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
  
  Alex Diener adiener@sacredsoftware.net
*/

#ifndef __ENEMY_VIEW_H__
#define __ENEMY_VIEW_H__

typedef struct EnemyView EnemyView;

#include "convergence/MovingEntityView.h"

#define EnemyView_structContents \
	MovingEntityView_structContents \
	\
	GLuint healthVBOID; \
	GLuint healthEBOID;

struct EnemyView {
	EnemyView_structContents
};

EnemyView * EnemyView_create(compat_type(MovingEntityModel *) modelPtr);
void EnemyView_init(compat_type(EnemyView *) selfPtr, compat_type(MovingEntityModel *) modelPtr);
void EnemyView_dispose(compat_type(EnemyView *) selfPtr);

void EnemyView_draw(compat_type(EnemyView *) selfPtr, Matrix modelviewMatrix, double deltaTime);

#endif
