/*
  Copyright (c) 2011 Alex Diener
  
  This software is provided 'as-is', without any express or implied
  warranty. In no event will the authors be held liable for any damages
  arising from the use of this software.
  
  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:
  
  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
  
  Alex Diener adiener@sacredsoftware.net
*/

#ifndef __GAME_OBJECT_VIEW_H__
#define __GAME_OBJECT_VIEW_H__

typedef struct GameObjectView GameObjectView;

#include "3dmath/Matrix.h"
#include "convergence/GameObjectModel.h"
#include "stemobject/StemObject.h"

#define GameObjectView_structContents \
	StemObject_structContents \
	\
	GameObjectModel * model; \
	int sortOrder; \
	bool markedForRemoval; \
	\
	void (* draw)(compat_type(GameObjectView *) self, Matrix modelviewMatrix, double deltaTime);

struct GameObjectView {
	GameObjectView_structContents
};

GameObjectView * GameObjectView_create(compat_type(GameObjectModel *) modelPtr);
void GameObjectView_init(compat_type(GameObjectView *) selfPtr, compat_type(GameObjectModel *) modelPtr);
void GameObjectView_dispose(compat_type(GameObjectView *) selfPtr);

#endif
