/*
  Copyright (c) 2011 Alex Diener
  
  This software is provided 'as-is', without any express or implied
  warranty. In no event will the authors be held liable for any damages
  arising from the use of this software.
  
  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:
  
  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
  
  Alex Diener adiener@sacredsoftware.net
*/

#ifndef __HEAL_POWERUP_MODEL_H__
#define __HEAL_POWERUP_MODEL_H__

typedef struct HealPowerupModel HealPowerupModel;

#include "convergence/GameObjectModel.h"

#define HealPowerupModel_structContents \
	GameObjectModel_structContents \
	\
	int rank; \
	int amount; \
	float radius; \
	Vector2 position;

struct HealPowerupModel {
	HealPowerupModel_structContents
};

HealPowerupModel * HealPowerupModel_create(DungeonRoomStateModel * stateModel, int rank, Vector2 position);
void HealPowerupModel_init(compat_type(HealPowerupModel *) selfPtr, DungeonRoomStateModel * stateModel, int rank, Vector2 position);
void HealPowerupModel_initCopy(compat_type(HealPowerupModel *) selfPtr, compat_type(HealPowerupModel *) originalPtr);
void HealPowerupModel_dispose(compat_type(HealPowerupModel *) selfPtr);

compat_type(HealPowerupModel *) HealPowerupModel_copy(compat_type(HealPowerupModel *) selfPtr);
struct rect4f HealPowerupModel_roughBounds(compat_type(HealPowerupModel *) selfPtr);
struct collisionGeometry HealPowerupModel_collisionGeometry(compat_type(HealPowerupModel *) selfPtr);
bool HealPowerupModel_wouldCollide(compat_type(HealPowerupModel *) selfPtr, compat_type(GameObjectModel *) objectPtr);
void HealPowerupModel_collision(compat_type(HealPowerupModel *) selfPtr, compat_type(GameObjectModel *) objectPtr, const struct collision collision, float time);

#endif
