/*
  Copyright (c) 2011 Alex Diener
  
  This software is provided 'as-is', without any express or implied
  warranty. In no event will the authors be held liable for any damages
  arising from the use of this software.
  
  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:
  
  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
  
  Alex Diener adiener@sacredsoftware.net
*/

#ifndef __PLAYER_INPUT_CONTROLLER_H__
#define __PLAYER_INPUT_CONTROLLER_H__

typedef struct PlayerInputController PlayerInputController;

#include "convergence/InputController.h"
#include "convergence/PlayerModel.h"

#define PlayerInputController_structContents \
	InputController_structContents \
	\
	PlayerModel * playerModel; \
	\
	void (* setPlayerModel)(compat_type(PlayerInputController *) self, compat_type(PlayerModel *) playerModel);

struct PlayerInputController {
	PlayerInputController_structContents
};

PlayerInputController * PlayerInputController_create(compat_type(PlayerModel *) playerModelPtr, PlayerInputMap * inputMap);
void PlayerInputController_init(compat_type(PlayerInputController *) selfPtr, compat_type(PlayerModel *) playerModelPtr, PlayerInputMap * inputMap);
void PlayerInputController_dispose(compat_type(PlayerInputController *) selfPtr);

bool PlayerInputController_triggerAction(compat_type(PlayerInputController *) selfPtr, Atom actionID);
bool PlayerInputController_releaseAction(compat_type(PlayerInputController *) selfPtr, Atom actionID);
void PlayerInputController_setPlayerModel(compat_type(PlayerInputController *) selfPtr, compat_type(PlayerModel *) playerModelPtr);

#endif
